#!/bin/bash
# s100/dsl startup, r.mauser, 20080507

if [ -f /cdrom/config/add_modules.dep ] ; then
   cat /cdrom/config/add_modules.dep >> /lib/modules/2.4.31/modules.dep
fi

if [ -f /cdrom/config/all.cfg ] ; then
   cp /cdrom/config/all.cfg /opt/all.cfg
   echo >> /opt/all.cfg
   XPL=`echo \`/bin/grep -v "#" /cdrom/config/all.cfg | /usr/bin/cut -d"=" -f0\``
   echo "export $XPL" >> /opt/all.cfg
fi

. /opt/all.cfg

loadkeys de

######### Network Stuff ###################

modprobe ipw2200

NDEV="0 1 2"
for ND in $NDEV ; do 
   DEV=`eval echo '$'NET_DEV_${ND}`
   if [ "$DEV" ] ; then
      if [ "$DEV" == "dhcp" ] ; then
         /sbin/pump -i eth$ND
      else 
         /sbin/ifconfig eth$ND `echo $DEV | /usr/bin/cut -d"|" -f1` netmask `echo $DEV | /usr/bin/cut -d"|" -f2` broadcast `echo $DEV | /usr/bin/cut -d"|" -f3` up
      fi
   fi
done

sleep 3

if ! [ "`/sbin/ifconfig | /bin/grep $LNIF`" ] ; then
   /sbin/ifconfig $LNIF 192.168.50.1 netmask 255.255.255.0 broadcast 192.168.50.255 up
fi

if [ -f /cdrom/config/routes.cfg ] ; then
   . /cdrom/config/routes.cfg
fi
/sbin/route add -net 224.0.0.0 netmask 240.0.0.0 dev $LNIF

if [ "$IP_FWD" ] ; then
   echo -n "$IP_FWD" > /proc/sys/net/ipv4/ip_forward
else 
   echo -n "0" > /proc/sys/net/ipv4/ip_forward
fi


############################################

/bin/hostname $HOSTNAME
echo $HOSTNAME > /etc/hostname

( /usr/bin/ntpdate time2 && /sbin/hwclock -w ) >> /var/log/ntpdate.log 2>&1

echo "test -s /opt/profile.local && . /opt/profile.local" > /root/.bash_profile


########### SSH Host-Keys ################
if [ -d /cdrom/config/ssh ] ; then
   cp -p /cdrom/config/ssh/ssh* /etc/ssh/
   /bin/chmod 600 /etc/ssh/ssh*
   /bin/chmod 644 /etc/ssh/ssh*.pub
   /bin/chmod 644 /etc/ssh/*config
fi

########### SSH User-Keys ##############
mkdir /root/.ssh
/bin/chown root:root /root/.ssh
/bin/chmod 2700 /root/.ssh
mkdir /home/dsl/.ssh
/bin/chown dsl:staff /home/dsl/.ssh
/bin/chmod 2700 /home/dsl/.ssh
if [ -f /cdrom/config/authorized_keys ] ; then
   /bin/cat /cdrom/config/authorized_keys > /root/.ssh/authorized_keys
   /bin/cat /cdrom/config/authorized_keys > /home/dsl/.ssh/authorized_keys
elif [ -d /cdrom/config/_ssh ] ; then
   cp /cdrom/config/_ssh/* /home/dsl/.ssh/
   cp /cdrom/config/_ssh/* /root/.ssh/
fi

if [ -d /home/dsl/.ssh ] ; then
   /bin/chown dsl:staff /home/dsl/.ssh/*
   /bin/chmod 600 /home/dsl/.ssh/*
fi

if [ -d /root/.ssh ] ; then
   /bin/chown root:root /root/.ssh/*
   /bin/chmod 600 /root/.ssh/*
fi

################# VNC ###################
if [ -d /cdrom/config/vnc ] ; then
   if ! [ -d /home/dsl/.vnc ] ; then 
      mkdir /home/dsl/.vnc
      /bin/chown dsl:staff /home/dsl/.vnc
      /bin/chmod 700 /home/dsl/.vnc
   fi
   cp /cdrom/config/vnc/* /home/dsl/.vnc
   /bin/chown dsl:staff /home/dsl/.vnc/*
   /bin/chmod 600 /home/dsl/.vnc/*
fi

################# HOSTNAME ###############
if [ -f /cdrom/config/hosts ] ; then
  echo "127.0.0.1       localhost $HOSTNAME" > /etc/hosts
  /bin/cat /cdrom/config/hosts >> /etc/hosts
fi

################ CRONTAB ################
if [ -f /cdrom/config/crontab ] ; then
  echo "* * * * * * echo Cron timestamp `date` >> /tmp/crontest" > /opt/crontab
  /bin/cat /cdrom/config/crontab >> /opt/crontab
fi

############### APPLICATION STUFF ############
if [ -f /cdrom/config/radio.sh ] ; then
  cp /cdrom/config/radio.sh /opt/arem/select.sh
fi

if [ -f /cdrom/config/multicli.cfg ] ; then
  cp /cdrom/config/multicli.cfg /opt/multicli.cfg
fi

if [ "$XRES" ] ; then 
   if [ "$MOUSE" ] ; then 
     echo "exec /usr/bin/X11/Xvesa -mouse ${MOUSE} -screen ${XRES}x16 -s 0 -shadow -I &>/dev/null" > /home/dsl/.xserverrc
   else 
     echo "exec /usr/bin/X11/Xvesa -screen ${XRES}x16 -s 0 -shadow -I &>/dev/null" > /home/dsl/.xserverrc
   fi
fi

/etc/init.d/ssh start

/usr/bin/nohup /usr/local/bin/MyCron &

mkdir /mnt2

rm -f /etc/motd
################################
/bin/cat << EOF > /etc/motd
 
 Welcome To $HOSTNAME 

EOF
################################

# sleep 2

/etc/init.d/portmap start

# /usr/bin/send_ip 88.198.1.134 -u -n > /var/log/ipchk.log 2>&1


/usr/bin/aremserv >/dev/null 2>&1 &
# /opt/led.sh start
/usr/bin/gpio_out >/dev/null 2>&1 &

MY_IP=`/sbin/ifconfig $LNIF | /bin/grep inet | /usr/bin/cut -d" " -f 12 | /usr/bin/cut -d":" -f 2`;
export MY_IP

if [ -f /cdrom/config/smb.conf ] ; then 
   cp /cdrom/config/smb.conf /opt/samba/smb.conf
fi


if [ "$USBDEV" ] ; then
   /usr/bin/automounter.sh >/dev/null 2>&1 &
fi

if [ "$REMDIR" ] && [ -x /usr/bin/smbmount ] ; then
   REMIP=`echo $REMDIR | /usr/bin/cut -d"/" -f3`
   if ! [ "`/bin/ping -c 3 $REMIP | /bin/grep -i unreachable`" ] ; then
      /usr/bin/smbmount $REMDIR /mnt2 -o ro,guest,dmask=0777,fmask=0755
   fi
fi

/usr/bin/hereami >/dev/null 2>&1 &
/opt/monkey/bin/banana start >/dev/null 2>&1


/etc/init.d/sms_gw start
