#!/bin/sh

. /opt/all.cfg

AVAIL=`/usr/bin/wget -O - -q http://mail.ulm.net/cgi-bin/s100ver.cgi`
INST=`/bin/gunzip -c /cdrom/backup.tar.gz | /bin/tar -xO etc/ver | /usr/bin/cut -d"|" -f2`
RUNN=`/bin/cat /etc/ver | /usr/bin/cut -d"|" -f2`
DO=0
PMT=""

echo "version available: $AVAIL"
echo "version installed: $INST"
echo "version running:   $RUNN"

if [ `echo $AVAIL | /usr/bin/tr -d "."` -gt `echo $INST | /usr/bin/tr -d "."` ] ; then
   DO=2
fi


if [ `echo $INST | /usr/bin/tr -d "."` -gt `echo $RUNN | /usr/bin/tr -d "."` ] ; then
   DO=1
fi


if [ $DO -ne 0 ] && ! [ `/usr/bin/whoami` == "root" ] ; then
   echo "update can only be triggered by root"
   exit 0
fi

if [ $DO -eq 1 ] ; then
   echo "installed version is newer than the running version"
   read -n 1 -p "reboot now ? (y/n) " PMT
   echo
   if [ "$PMT" == "y" ] ; then
      /sbin/reboot
   fi
elif [ $DO -eq 2 ] ; then
   echo "new version is available for update"
   read -n 1 -p "update now ? (y/n) " PMT
   echo
   if [ "$PMT" == "y" ] ; then
      /bin/mv /cdrom/backup.tar.gz /cdrom/backup.tar.gz.old
      /usr/bin/wget -O /cdrom/backup.tar.gz -q http://mail.ulm.net/s100dwnld/backup.tar.gz
      if ! [ -f /cdrom/backup.tar.gz ] ; then
         /bin/mv /cdrom/backup.tar.gz.old /cdrom/backup.tar.gz
         echo "update failed !"
         exit -1
      fi

      /bin/sync
      echo 
      exec $0
   fi
else 
   echo "no update necessary ..."
fi
